routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('index');
})->name('index');

Route::get('/create', function () {
    return view('create');
})->name('create');

Route::resource('students', StudentController::class);

app/Student.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Student extends Model
{
    //
}

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/API/StudentController.php
<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Student;
use Illuminate\Http\Request;

class StudentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $students = Student::all();
        return $students;
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/StudentController.php
<?php

namespace App\Http\Controllers;

use App\Student;
use Illuminate\Http\Request;

class StudentController extends Controller
{
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $students = Student::all();
        return view('create', compact('students'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $data = $request->all();


        $newstudent = new Student;

        $newstudent->firstname = $data['firstname'];
        $newstudent->lastname = $data['lastname'];
        $newstudent->birthdate = $data['birthdate'];
        $newstudent->grades = $data['grades'];
        $newstudent->save();

        return redirect()->route('index');
    }
}

resources/views/create.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Test d'ingresso</title>
</head>

<body>

    <div id="app">

        <h1>Test d'ingresso</h1>

        <!-- Esercizio 3 -->
        <h3>Crea nuovo studente:</h3>

        <form action="{{ route('students.store') }}" method="post">
            @csrf

            <div class="form-group">
                <label for="firstname">Nome</label>
                <input type="text" class="form-control" name="firstname" id="firstname"
                    aria-describedby="firstnameHelperr" placeholder="Aggiungi il nome dello studente" />
            </div>

            <div class="form-group">
                <label for="lastname">Cognome</label>
                <input type="text" class="form-control" name="lastname" id="lastname"
                    aria-describedby="lastnameHelperr" placeholder="Aggiungi il nome dello studente" />
            </div>

            <div class="form-group">
                <label for="birthdate">Data di nascita</label>
                <input type="text" class="form-control" name="birthdate" id="birthdate"
                    aria-describedby="birthdateHelperr" placeholder="Aggiungi la data di nascita dello studente" />
            </div>

            <div class="form-group">
                <label for="grades">Voti</label>
                <input type="text" class="form-control" name="grades" id="grades" aria-describedby="gradesHelperr"
                    placeholder="Aggiungi i voti dello studente" />
            </div>



            <button type="submit">
                <h5 class="m-0 p-1">Crea</h5>
            </button>
        </form>

    </div>

    <!-- VueJS -->
    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.14/dist/vue.js"></script>
    <!-- CDN Axios -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.21.1/axios.min.js"
        integrity="sha512-bZS47S7sPOxkjU/4Bt0zrhEtWx0y0CRkhEp8IckzK+ltifIIE9EMIMTuT/mEzoIMewUINruDBIR/jJnbguonqQ=="
        crossorigin="anonymous" referrerpolicy="no-referrer"></script>
    <!-- MyScript -->
    <script src="{{ asset('js/app.js') }}" defer></script>
</body>

</html>

resources/views/index.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Test d'ingresso</title>
</head>

<body>

    <div id="app">

        <h1>Test d'ingresso</h1>

        <!-- Esercizio 1 -->
        <h3>Fase 1:</h3>
        <span>Posizione n. con 10 cifre: @{{ risultato_fibonacci }}</span>

        <!-- Esercizio 2 -->
        <h3>Fase 2:</h3>
        <span>Calcolo età studente: @{{ eta }}</span> <br>
        <span>Calcolo media voti studente: @{{ media }}</span>

        <!-- Esercizio 3 -->
        <h3>Fase 3:</h3>
        <h4>Lista studenti: [GET] [Con Chiamata Axios]</h4>
        <div v-for="studente in studenti">
            <span>@{{ studente . firstname }} @{{ studente . lastname }}</span> <br>
            <span>Data di nascita: @{{ studente . birthdate }}</span> <br>
            <span>Voti: @{{ studente . grades }}</span>
        </div>
        <h4>Crea nuovo studente: [POST]</h4>
        <a href="{{ route('create') }}">Crea nuovo studente da qui!</a>

    </div>

    <!-- VueJS -->
    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.14/dist/vue.js"></script>
    <!-- CDN Axios -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.21.1/axios.min.js"
        integrity="sha512-bZS47S7sPOxkjU/4Bt0zrhEtWx0y0CRkhEp8IckzK+ltifIIE9EMIMTuT/mEzoIMewUINruDBIR/jJnbguonqQ=="
        crossorigin="anonymous" referrerpolicy="no-referrer"></script>
    <!-- MyScript -->
    <script src="{{ asset('js/app.js') }}" defer></script>
</body>

</html>